//
// C++ Interface: databasethread
//
// Description:
//
//
// Author: Roland Weigert <roweigert@t-online.de>, (C) 2008
//
// Copyright: See COPYING file that comes with this distribution
//
//

/**
 *@file databasethread.h
 *
 *This file holds the class for the extra thread-processing databaseevents.<br>
 *It passes through all events to the databaseinterface.
 *@author Roland Weigert
 *@date 10-07-2008
 *@todo Write all
 */

#ifndef _DATABASETHREAD_H_
#define _DATABASETHREAD_H_

#include <QString>
#include <QStringList>
#include <QThread>

#include "database/databaseinterface.h"

/**
 * @brief databasethread-class
 * This class is used for throwing out all databaserelated stuff into an extra thread
 */
class databasethread :public QThread
  {
    Q_OBJECT
  public:
    databasethread();
    ~databasethread();
  public slots:
    void setdatabasetype(int type);
    void testthreading();
  signals:
    void thread_testthreading();
  private:
    databaseinterface *db_interface;
  protected:
    void run();

  };

#endif
