//
// C++ Implementation: communicationinterface
//
// Description:
//
//
// Author: Roland Weigert <roweigert@t-online.de>, (C) 2009
//
// Copyright: See COPYING file that comes with this distribution
//
//

#include "global-stuff/communicationinterface.h"

void communicationinterface::requestslot(QString sender,QString type,QVariant data)
{
  emit requestsignal(sender,type, data);
}

void communicationinterface::requestslot(QString sender,QString type, QList<QVariant> data)
{
  emit requestsignal(sender,type, data);
}

advancedcommunicationinterface::advancedcommunicationinterface():
    currentid(0)
{}

advancedcommunicationinterface::~advancedcommunicationinterface()
{}

void advancedcommunicationinterface::sendmessage(messageobject *object)
{
  object->lock();
  object->setmessageid(++currentid);
  messagelist.append(object);
  object->unlock();
  emit requestsignal(object->getdestination(),object);
}

void advancedcommunicationinterface::deletemessage(const long id)
{
  for (long i=0;i<messagelist.count();i++)
    {
      if (messagelist.at(i)->getmessageid()==id)
        {
          messagelist.removeAt(i);
          break;
        }
    }
}

//##########################################################################################################

messageobject::messageobject(const QString snd, const QStringList dest, QString dtype, QVariant dat):
    sender(snd),
    destination(dest),
    type(dtype),
    data(dat),
    id(-1)
{}

void messageobject::setmessageid(const long idnr)
{
  id=idnr;
}
const int messageobject::confirm(const QString confirmer)
{
  if (destination.contains(confirmer))
      destination.removeAt(destination.indexOf(confirmer));
  return destination.count();
}

const long messageobject::getmessageid()
{
  return id;
}

const QString messageobject::getsender()
{
  return sender;
}

const QStringList messageobject::getdestination()
{
  return destination;
}

const QString messageobject::gettype()
{
  return type;
}

const QVariant messageobject::getdata()
{
  return data;
}
