//
// C++ Implementation: mplayerinterface
//
// Description:
//
//
// Author: Roland Weigert <roweigert@t-online.de>, (C) 2009
//
// Copyright: See COPYING file that comes with this distribution
//
//

#include "player/mplayerinterface.h"

extern rcfile *settingsfile;

mplayerinterface::mplayerinterface(const QString filename,QObject *parent):
    QObject(parent),
    mplayerprocess(new QProcess(this)),
    startok(false)
{
  QString executable="mplayer";
//Find the executable
  QString path;
  bool found=false;
  for (int i=0;i<settingsfile->getsearchpathes().count();i++)
    {
      QFile checkpath(QString("%1/%2").arg(settingsfile->getsearchpathes().at(i),executable));
      if (checkpath.exists())
        {
          executable=QString("%1/%2").arg(settingsfile->getsearchpathes().at(i),executable);
          found=true;
          break;
        }
    }
  if (found)
    {
      QStringList parameters;
      parameters<<"-slave"<<"-nolirc"<<filename;
      mplayerprocess->start(executable,parameters);
      startok=true;
      connect (mplayerprocess,SIGNAL(readyReadStandardOutput()),this,SLOT(processtracking()));
      connect (mplayerprocess,SIGNAL(finished(int,QProcess::ExitStatus)),this,SLOT(processfinished(int)));
    }
}

mplayerinterface::~mplayerinterface()
{}

const bool mplayerinterface::started()
{
  return startok;
}

const bool mplayerinterface::pause()
{
  QString seekstring=QString("pause \n");
  mplayerprocess->write(seekstring.toAscii());
}

void mplayerinterface::seek(int newlocation)
{
  QString seekstring=QString("seek %1 2\n").arg(QString::number(newlocation));
  mplayerprocess->write(seekstring.toAscii());
}

void mplayerinterface::processtracking()
{
  QByteArray receiveddata=mplayerprocess->readAllStandardOutput();
  QString data=QString::fromLocal8Bit(receiveddata.constData());
  if (data.contains("%")&&data.contains("of"))
    {
      data=data.left(data.indexOf("("));
      data=data.right(data.length()-(1+data.indexOf(":")));
      bool ok=false;
      float time=data.toFloat(&ok);
      if (ok)
        emit actualtime(time);
    }
}

void mplayerinterface::processfinished(int)
{
  emit finished();
}
