//
// C++ Interface: mplayerinterface
//
// Description:
//
//
// Author: Roland Weigert <roweigert@t-online.de>, (C) 2009
//
// Copyright: See COPYING file that comes with this distribution
//
//
/**
 *@file mplayerinterface.h
 *
 *Thisfile holds the interface to mplayer.
 *@author Roland Weigert
 *@date 07-03-2009
 *@todo Write all
 */

#ifndef _MPLAYERINTERFACE_H_
#define _MPLAYERINTERFACE_H_

#include <QString>
#include <QFileInfo>
#include <QProcess>
#include <QObject>

#include "settings/rcfile.h"

class mplayerinterface :public QObject
  {
    Q_OBJECT
  public:
    mplayerinterface(const QString file,QObject *parent);
    ~mplayerinterface();
    const bool started();
    const bool pause();
    void seek(int newlocation);
  signals:
    void actualtime(const float);
    void finished();
  private:
    QProcess *mplayerprocess;
    bool startok;
  private slots:
    void processtracking();
    void processfinished(int);
  };

#endif
