//
// C++ Implementation: playerlink
//
// Description:
//
//
// Author: Roland Weigert <roweigert@t-online.de>, (C) 2009
//
// Copyright: See COPYING file that comes with this distribution
//
//
#include "player/playerlink.h"

extern rcfile *settingsfile;
extern advancedcommunicationinterface *adv_comm_if;

playerlink::playerlink(const QString file,QObject *parent):
    QObject(parent),
    mplayerlink(0),
    currentplayed(file),
    startok(false)
{
//For the moment there is only mplayersuport, but through the settingsfile, this can get changed
  if (mplayerlink)
    delete mplayerlink;
  mplayerlink=new mplayerinterface(currentplayed,this);
  if (mplayerlink->started())
    {
      startok=true;
      connect(mplayerlink,SIGNAL(actualtime(const float)),this,SIGNAL(actualtime(const float)));
      connect(mplayerlink,SIGNAL(finished()),this,SIGNAL(finished()));
    }
  else
    {
      startok=false;
      delete mplayerlink;
      mplayerlink=NULL;

    }
}

playerlink::~playerlink()
{}

const bool playerlink::started()
{
  return startok;
}

const bool playerlink::pause()
{
  if (mplayerlink)
    mplayerlink->pause();
}

void playerlink::seek(const int time)
{
  if (mplayerlink)
    mplayerlink->seek (time);
}
