//
// C++ Interface: playerlink
//
// Description:
//
//
// Author: Roland Weigert <roweigert@t-online.de>, (C) 2009
//
// Copyright: See COPYING file that comes with this distribution
//
//
/**
 *@file playerlink.h
 *
 *This file holds the classthe masterclass for all playerlinks,
 * this is the right class to direct connect to, since it also handles playerchanges through the settings.
 *@author Roland Weigert
 *@date 07-03-2009
 *@todo Write all
 */

#ifndef _PLAYERLINK_H_
#define _PLAYERLINK_H_

#include <QDir>
#include <QString>
#include <QObject>

#include "settings/rcfile.h"
#include "global-stuff/communicationinterface.h"
#include "player/mplayerinterface.h"

class playerlink : public QObject
  {
    Q_OBJECT
  public:
    playerlink(const QString file,QObject *parent);
    ~playerlink();
    const bool pause();
    void seek(const int time);
    const bool started();
  private:
    //We need this to change the playingengine, while playing
    QString currentplayed;
    mplayerinterface *mplayerlink;
  bool startok;
	  private slots:
  signals:
    void actualtime(const float);
    void finished();
  };

#endif
