/***************************************************************************
 *   Copyright (C) 2007 by Roland Weigert   *
 *   roweigert@t-online.de             *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

/**
 *@file discselector.h
 *
 *This file holds the class for the discselctordialog.<br>
 *It takes a QList<freedbalbum> and emits signlas with userchoices.
 *@author Roland Weigert
 *@date 01-08-2007
 *@todo Write Documentation
 */

#ifndef _DISCSELECTOR_H_
#define _DISCSELECTOR_H_

#include <QList>
#include <QString>
#include <QStringList>
#include <QLabel>
#include <QDialog>
#include <QTreeWidget>
#include <QPushButton>
#include <QLayout>
#include <QCloseEvent>

#include "freedbinterface.h"

/**
 * @brief discselectorclass
 * This class gets used, when freedb offers a choice of discs
 */
class discselector :public QDialog
  {
    Q_OBJECT
  public:
    discselector(const QList<freedbalbum> choices);
    ~discselector();
  private:
    QList<freedbalbum> albumlist;
    QVBoxLayout *layout;
    QHBoxLayout *buttonlayout;
    QLabel *infotext;
    QTreeWidget *choicestree;
    QPushButton *okbutton;
    QPushButton *trybutton;
    QPushButton *cancelbutton;
    freedbalbum selectedalbum;
  private slots:
    void tryclicked();
    void okclicked();
    void itemchanged(QTreeWidgetItem * item ,int col);
    void closeEvent(QCloseEvent *event);
  signals:
    void trysignal(const freedbalbum album);
    void oksignal(const freedbalbum album);
    void cancelsignal();
  };

#endif
