/***************************************************************************
 *   Copyright (C) 2007 by Roland Weigert   *
 *   roweigert@t-online.de             *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "trackitem.h"

trackitem::trackitem(int number,int valid,QString time ):
    readbox(new QCheckBox),
    artistledit(new QLineEdit),
    titleledit(new QLineEdit),
    songtime(new QLabel(time)),
    layout(new QHBoxLayout)
{
  this->setMinimumSize(300,30);
  QString displaynumber;
  if (number<10)
    displaynumber=QString(tr("0%1")).arg(QString::number(number));
  else
    displaynumber=QString::number(number);
  tracknumber=new QLabel (displaynumber);
  layout->addWidget(readbox,1);
  layout->addWidget(tracknumber,1);
  layout->addWidget(artistledit,3);
  layout->addWidget(titleledit,5);
  layout->addWidget(songtime,1);
  layout->setMargin(2);
  this->setLayout(layout);
  if (valid==4)
    {
      readbox->setEnabled(FALSE);
      artistledit->setEnabled(FALSE);
      artistledit->setText(tr("Multimedia-Track"));
      titleledit->setText(tr("Not rippable"));
      titleledit->setEnabled(FALSE);
    }
    connect(readbox,SIGNAL(stateChanged(int)),this,SIGNAL(checkboxchanged()));
}

trackitem::~trackitem()
{
  delete tracknumber;
  delete readbox;
  delete artistledit;
  delete titleledit;
  delete songtime;
  delete layout;
}

void trackitem::changeartist(const QString newname)
{
  if (artistledit->isEnabled())
    artistledit->setText(newname);
}

void trackitem::changetitle(const QString newname)
{
  if (titleledit->isEnabled())
    titleledit->setText(newname);
}

const QString trackitem::gettitle() const
  {
    return titleledit->text();
  }

const QString trackitem::getartist() const
  {
    return artistledit->text();
  }

const bool trackitem::getchecked() const
  {
    return readbox->isChecked();
  }

void trackitem::setchecked(const bool value)
{
  readbox->setChecked(value);
}
