/***************************************************************************
 *   Copyright (C) 2007 by Roland Weigert   *
 *   roweigert@t-online.de             *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

/**
 *@file tracklister.h
 *The class that displays a lister with trackitems<br>
 *
 *@author Roland Weigert
 *@date 29-07-2007
 *@todo Write documentation
 */

#ifndef _TRACKLISTER_H_
#define _TRACKLISTER_H_

#include <QList>
#include <QScrollArea>
#include <QLayout>
#include <QGroupBox>
#include <QWidget>

#include "trackitem.h"
#include "cdinterface.h"

struct selectionobject;

class tracklister : public QScrollArea
  {
    Q_OBJECT
  public:
    tracklister(int trackcount,const toc *cdinfo);
    ~tracklister();
    void changetrack (int number,const QString newtitle);
    void changechecked(const int number,const int checked);
    const QList<selectionobject> getselection();
  private:
    QList<trackitem *> tracklist;
    QWidget *box;
    QVBoxLayout *layout;
    QLabel *header1;
    QLabel *header2;
    QLabel *header3;
    QLabel *header4;
    QLabel *header5;
    QHBoxLayout *headerlayout;
  signals:
    /**
    *This signal is emitted, when all trackitems need to update the artist
    */
    void artistsignal(const QString);
    /**
    *This signal is emitted, when checkboxes in the list are changed
    */
    void checkedtracks(const int);
  private slots:
    void checkallboxes();
  };

/**
*@brief This struct is needed for talk to the outsideworld, to get inforamtion, what tracks are selected
*/
struct selectionobject
  {
    int number;
    QString artist;
    QString title;
  };

#endif
